/************************************************************
Module name: ModUse.C
Notices: Copyright (c) 1995 Jeffrey Richter
************************************************************/


#include "..\AdvWin32.H"    /* See Appendix B for details. */
#include <windows.h>
#include <windowsx.h>

#pragma warning(disable: 4001)      /* Single-line comment */

#include "Resource.H"
#include "Module.H"


/////////////////////////////////////////////////////////////


#define LIBNAME   "Module"

#if defined(_X86_)
   #if defined(_DEBUG)
      #pragma comment(lib, "Dbg_x86\\" LIBNAME)
   #else
      #pragma comment(lib, "Rel_x86\\" LIBNAME)
   #endif
#elif defined(_MIPS_)
   #if defined(_DEBUG)
      #pragma comment(lib, "Dbg_MIPS\\" LIBNAME)
   #else
      #pragma comment(lib, "Rel_MIPS\\" LIBNAME)
   #endif
#elif defined(_ALPHA_)
   #if defined(_DEBUG)
      #pragma comment(lib, "Dbg_Alph\\" LIBNAME)
   #else
      #pragma comment(lib, "Rel_Alph\\" LIBNAME)
   #endif
#else
   #error Modification required for this CPU platform.
#endif


/////////////////////////////////////////////////////////////


UINT g_uMsgModCntChange = 0;


/////////////////////////////////////////////////////////////


BOOL Dlg_OnInitDialog (HWND hwnd, HWND hwndFocus,
   LPARAM lParam) {

   // Associate an icon with the dialog box.
   SetClassLong(hwnd, GCL_HICON, (LONG)
      LoadIcon((HINSTANCE) GetWindowLong(hwnd, GWL_HINSTANCE),
         __TEXT("ModUse")));

   // Force the static control to be initialized correctly.
   PostMessage(hwnd, g_uMsgModCntChange, 0, 0);
   return(TRUE);
}


/////////////////////////////////////////////////////////////


void Dlg_OnCommand (HWND hwnd, int id, HWND hwndCtl,
   UINT codeNotify) {

   switch (id) {
      case IDCANCEL:
         EndDialog(hwnd, id);
         break;
   }
}


/////////////////////////////////////////////////////////////


BOOL CALLBACK Dlg_Proc (HWND hDlg, UINT uMsg,
   WPARAM wParam, LPARAM lParam) {

   BOOL fProcessed = TRUE;

   if (uMsg == g_uMsgModCntChange) {
      SetDlgItemInt(hDlg, IDC_USAGECOUNT,
         GetModuleUsage(), FALSE);
   }

   switch (uMsg) {
      HANDLE_MSG(hDlg, WM_INITDIALOG, Dlg_OnInitDialog);
      HANDLE_MSG(hDlg, WM_COMMAND, Dlg_OnCommand);

      default:
         fProcessed = FALSE;
         break;
   }
   return(fProcessed);
}


/////////////////////////////////////////////////////////////


int WINAPI WinMain (HINSTANCE hinstExe,
   HINSTANCE hinstPrev, LPSTR lpszCmdLine, int nCmdShow) {

   // Get the numeric value of the systemwide window message
   // used by the module to notify all top-level windows when
   // the module's usage count has changed.
   g_uMsgModCntChange =
      RegisterWindowMessage(__TEXT("MsgModUsgCntChange"));

   DialogBox(hinstExe, MAKEINTRESOURCE(IDD_MODUSE),
      NULL, Dlg_Proc);

   return(0);
}


//////////////////////// End Of File ////////////////////////
