/************************************************************
Module name: MultInst.C
Notices: Copyright (c) 1995 Jeffrey Richter
************************************************************/


#include "..\AdvWin32.H"    /* See Appendix B for details. */
#include <windows.h>

#pragma warning(disable: 4001)      /* Single-line comment */

#include "Resource.H"


/////////////////////////////////////////////////////////////


// We instruct the compiler to put the g_lUsageCount data
// variable in its own data section called Shared. We
// then instruct the linker that we want the data in this
// section to be shared by all instances of this application.
#pragma data_seg("Shared")

LONG g_lUsageCount = -1;

#pragma data_seg()


/////////////////////////////////////////////////////////////


// Instruct the linker to make the Shared section 
// readable, writable, and shared.
#pragma comment(lib, "msvcrt " "-section:Shared,rws")


/////////////////////////////////////////////////////////////


int WINAPI WinMain (HINSTANCE hinstExe,
   HINSTANCE hinstPrev, LPSTR lpszCmdLine, int nCmdShow) {

   // An instance is running; increment the counter.
   BOOL fFirstInstance = 
      (InterlockedIncrement(&g_lUsageCount) == 0);

   // If more than one instance is running, tell
   // the user and terminate the program.
   if (!fFirstInstance) {
      MessageBox(NULL,
         __TEXT("Application is already running - ")
         __TEXT("Terminating this instance."),
         __TEXT("Multiple Instance"),
            MB_OK | MB_ICONINFORMATION);
   } else {

      // We are the only instance running; 
      // wait for the user to terminate us.
      MessageBox(NULL,
         __TEXT("Running first instance of application.\n")
         __TEXT("Select OK to terminate."),
         __TEXT("Multiple Instance"), 
         MB_OK | MB_ICONINFORMATION);
   }

   // We are no longer running; decrement the usage counter.
   InterlockedDecrement(&g_lUsageCount);

   return(0);
}


//////////////////////// End Of File ////////////////////////
