@Echo Off
REM Assume that Setup recognizes the CPU that we are running on.
SET RecognizedProcessor=1

REM If we are running on an x86, MIPS, or Alpha run the binary Setup.
IF NOT %PROCESSOR_ARCHITECTURE%x == x86x GOTO Notx86
Start %0\..\ISetup.exe
GOTO Exit

:Notx86
IF NOT %PROCESSOR_ARCHITECTURE%x == ALPHAx GOTO NotAlpha
Start %0\..\ASetup.exe
GOTO Exit

:NotAlpha
IF NOT %PROCESSOR_ARCHITECTURE%x == MIPSx GOTO NotMIPS
Start %0\..\MSetup.exe
GOTO Exit

:NotMIPS
SET RecognizedProcessor=0
REM Check to see if the user entered a command line parameter.
IF NOT %1x == x GOTO HaveCmdLineParm
REM  Display the "Usage" information.
ECHO This batch file installs the source code for "Advanced Windows."
ECHO.
ECHO Usage: SETUP (DestPath)
ECHO.
ECHO Where DestPath is the drive and path where the files 
ECHO should be copied to.  For example,
ECHO.
ECHO             %0 C:\AdvWin32
ECHO.
ECHO installs the source files to the AdvWin32 directory of drive C.
ECHO If this directory does not exist, it will be created.
GOTO Exit

:HaveCmdLineParm
REM  User entered a command-line parameter.  Let's get going...

REM  Attempt to create the specified subdirectory.
MkDir %1
IF EXIST %1 GOTO DirExists
REM  Unable to make the directory.
ECHO The directory (%1) could not be created.  Run Setup again
ECHO and specify a different (DestPath).
GOTO Exit

:DirExists
REM The subdirectory already exists.

REM Create an environment variable containing all of the subdirectories.
Set AllDirs=VMStat.05 SysInfo.05 VMMap.05 VMAlloc.06 FileRev.07 MMFShare.07
Set AllDirs=%AllDirs% CritSecs.09 Mutexes.09 SprMrkt.09 Bucket.09 DocStats.09
Set AllDirs=%AllDirs% CopyData.10 LISLab.10 ModUse.11 MultInst.11 
Set AllDirs=%AllDirs% TLSDyn.12 TLSStat.12 DiskInfo.13 AlertIO.13
Set AllDirs=%AllDirs% DirWalk.13 FileChng.13 SEHTerm.14 SEHExcpt.14 
Set AllDirs=%AllDirs% SEHSum.14 SEHSoft.14 PMRest.16 TInjLib.16

ECHO Creating the directory tree structure.
FOR %%d IN (%AllDirs%) DO IF NOT EXIST %1\%%d MkDir %1\%%d

ECHO.
ECHO Copying the source files.
FOR %%d IN (%AllDirs%) DO ECHO Installing sample application: %%d. & Copy %0\..\%%d\*.* %1\%%d > Nul

REM Copy all of the files in the root directory.
ECHO.
ECHO Installing auxiliary files.
FOR %%f IN (AdvWin32.h) DO Copy %0\..\%%f %1 > Nul

ECHO.
ECHO The files have been copied successfully.
CD %1
REM Start Notepad %1\AdvWin32.Txt


:Exit
REM If SETUP is running on a non-recognized CPU, the binary
REM ?SETUP.EXE does not run.  The user relies on this batch 
REM file for all information.  Just in case the user is running
REM this batch file from a GUI application, make sure that
REM we pause the information or the console window will vanish
REM with all of the text in it.
IF %RecognizedProcessor% == 0 PAUSE Press a key to exit SETUP.

REM Erase all environment variables created by this batch file.
SET AllDirs=
SET RecognizedProcessor=
