/************************************************************
Module name: ImgWalk.C
Notices: Copyright (c) 1995 Jeffrey Richter
************************************************************/


#include "..\AdvWin32.H"    /* See Appendix B for details. */

#include <windows.h>

#pragma warning(disable: 4001)      /* Single-line comment */

#include <stdio.h>
#include <tchar.h>


/////////////////////////////////////////////////////////////


BOOL WINAPI DllMain (HINSTANCE hinstDll, DWORD fdwReason, 
   LPVOID lpvReserved) {

   TCHAR szBuf[MAX_PATH * 30], szModName[MAX_PATH];

   if (fdwReason == DLL_PROCESS_ATTACH) {
      LPBYTE lp = NULL;
      MEMORY_BASIC_INFORMATION mbi;
      int nLen;
      szBuf[0] = 0;
      szBuf[1] = 0;

      while (VirtualQuery(lp, &mbi, sizeof(mbi))
         == sizeof(mbi)) {
         if (mbi.State == MEM_FREE)
            mbi.AllocationBase = mbi.BaseAddress;

         if ((mbi.AllocationBase == hinstDll) ||
             (mbi.AllocationBase != mbi.BaseAddress) ||
             (mbi.AllocationBase == NULL)) {
             // Do not add the module name to the list
             // if any of the following is true:
             // 1. If this region contains this DLL
             // 2. If this block is NOT the beginning of
             //    a region
             // 3. If the address is NULL
            nLen = 0;
         } else {
            nLen = GetModuleFileName((HINSTANCE)
               mbi.AllocationBase,
               szModName, ARRAY_SIZE(szModName));
         }

         if (nLen > 0) {
            _stprintf(_tcschr(szBuf, 0), __TEXT("\n%08X-%s"),
               mbi.AllocationBase, szModName);
         }

         lp += mbi.RegionSize;
      }

      MessageBox(NULL, &szBuf[1], NULL, MB_OK);
   }
   return(TRUE);
}


//////////////////////// End Of File ////////////////////////
