/*************************************************************
Module name: TInjLib.C
Notices: Copyright (c) 1995 Jeffrey Richter
*************************************************************/


#include "..\AdvWin32.H"     /* See Appendix B for details. */

#include <windows.h>
#pragma warning(disable: 4001)       /* Single-line comment */

#include <windowsx.h>

#include <stdio.h>
#include <tchar.h>

#include "InjLib.H"


//////////////////////////////////////////////////////////////


int WINAPI WinMain (HINSTANCE hinstExe, HINSTANCE hinstPrev, 
   LPSTR lpszCmdLine, int nCmdShow) {

   DWORD dwProcessId = 0;
   HANDLE hProcess;

   if ((lpszCmdLine == NULL) || (*lpszCmdLine == 0)) {
      MessageBox(NULL, 
         __TEXT("Usage: InjLib [ProcessID (in hex)]"), 
         __TEXT("InjLib"), MB_ICONINFORMATION | MB_OK);
         return(0);
   } else {
      sscanf(lpszCmdLine, "%x", &dwProcessId);
   }

   if (dwProcessId == 0) {
      // A command-line argument of 0 causes everything to
      // take place in the local process; this makes things
      // easier for debugging.
      dwProcessId = GetCurrentProcessId();
   }

   hProcess = OpenProcess(
      PROCESS_CREATE_THREAD |       // For CreateRemoteThread
      PROCESS_QUERY_INFORMATION |   // For VirtualQueryEx
      PROCESS_VM_OPERATION |        // For VirtualProtectEx
      PROCESS_VM_READ |             // For ReadProcessMemory
      PROCESS_VM_WRITE,             // For WriteProcessMemory
      FALSE, dwProcessId);
   if (hProcess == NULL) {
      MessageBox(NULL, (GetLastError() == ERROR_ACCESS_DENIED) ? 
         __TEXT("Insufficient access to process")
            : __TEXT("Invalid process Id"), 
         __TEXT("Inject Library Tester"), MB_OK);
   } else {
      TCHAR szLibFile[MAX_PATH];
      GetModuleFileName(hinstExe, szLibFile, sizeof(szLibFile));
      _tcscpy(_tcsrchr(szLibFile, __TEXT('\\')) + 1,
         __TEXT("ImgWalk.DLL"));
      MessageBox(NULL, InjectLib(hProcess, szLibFile) ? 
         __TEXT("Remote DLL Loaded") : __TEXT("Remote DLL failed load"),
         __TEXT("Inject Library Tester"), MB_OK);
      CloseHandle(hProcess);
   }

   return(0);
}


//////////////////////// End Of File /////////////////////////
