/************************************************************
Module name: TLSDyn.C
Notices: Copyright (c) 1995 Jeffrey Richter
************************************************************/


#include "..\AdvWin32.H"    /* See Appendix B for details. */
#include <windows.h>
#include <windowsx.h>

#pragma warning(disable: 4001)	    /* Single-line comment */

#include <tchar.h>
#include <stdio.h>      // For sprintf
#include <process.h>    // For _beginthreadex
#include "SomeLib.H"

#include "Resource.H"


/////////////////////////////////////////////////////////////


#define LIBNAME	"SomeLib"

#if defined(_X86_)
	#if defined(_DEBUG)
		#pragma comment(lib, "Dbg_x86\\" LIBNAME)
	#else
		#pragma comment(lib, "Rel_x86\\" LIBNAME)
	#endif
#elif defined(_MIPS_)
	#if defined(_DEBUG)
		#pragma comment(lib, "Dbg_MIPS\\" LIBNAME)
	#else
		#pragma comment(lib, "Rel_MIPS\\" LIBNAME)
	#endif
#elif defined(_ALPHA_)
	#if defined(_DEBUG)
		#pragma comment(lib, "Dbg_Alph\\" LIBNAME)
	#else
		#pragma comment(lib, "Rel_Alph\\" LIBNAME)
	#endif
#else
	#error Modification required for this CPU platform.
#endif


/////////////////////////////////////////////////////////////


HWND g_hwndLog = NULL;


/////////////////////////////////////////////////////////////


DWORD WINAPI ThreadFunc (LPVOID lpvThreadParm) {
   int nThreadNum = (int) lpvThreadParm;
   int nNumCycles = 4;
   TCHAR szBuf[100];
   LPCTSTR szString = LoadResString();

   while (nNumCycles--) {
      _stprintf(szBuf, __TEXT("Thread #%d: %s"),
         nThreadNum, szString);

      ListBox_AddString(g_hwndLog, szBuf);

      Sleep(nThreadNum * 50);
   }
   return(0);
}


/////////////////////////////////////////////////////////////


BOOL Dlg_OnInitDialog (HWND hwnd, HWND hwndFocus,
   LPARAM lParam) {

   int nThreadNum;

   // Associate an icon with the dialog box.
   SetClassLong(hwnd, GCL_HICON, (LONG)
      LoadIcon((HINSTANCE) GetWindowLong(hwnd, GWL_HINSTANCE),
      __TEXT("TLSDyn")));

   g_hwndLog = GetDlgItem(hwnd, IDC_LOG);


   for (nThreadNum = 1; nThreadNum <= 5; nThreadNum++) {
      HANDLE hThread;
      DWORD dwIDThread;

      hThread = BEGINTHREADEX(NULL, 0, ThreadFunc,
         (LPVOID) nThreadNum, 0, &dwIDThread);

      CloseHandle(hThread);
   }

   return(TRUE);
}


/////////////////////////////////////////////////////////////


void Dlg_OnCommand (HWND hwnd, int id, HWND hwndCtl,
   UINT codeNotify) {

   switch (id) {
      case IDCANCEL:
         EndDialog(hwnd, id);
         break;
   }
}


/////////////////////////////////////////////////////////////


BOOL CALLBACK Dlg_Proc (HWND hDlg, UINT uMsg,
   WPARAM wParam, LPARAM lParam) {

   BOOL fProcessed = TRUE;

   switch (uMsg) {
      HANDLE_MSG(hDlg, WM_INITDIALOG, Dlg_OnInitDialog);
      HANDLE_MSG(hDlg, WM_COMMAND, Dlg_OnCommand);

      default:
         fProcessed = FALSE;
         break;
   }
   return(fProcessed);
}


/////////////////////////////////////////////////////////////


int WINAPI WinMain (HINSTANCE hinstExe,
   HINSTANCE hinstPrev, LPSTR lpszCmdLine, int nCmdShow) {

   MessageBox(NULL, LoadResString(),
      __TEXT("String Before Dialog Box"), MB_OK);

   DialogBox(hinstExe, MAKEINTRESOURCE(IDD_TLSDYN),
      NULL, Dlg_Proc);

   MessageBox(NULL, LoadResString(),
      __TEXT("String After Dialog Box"), MB_OK);

   return(0);
}


//////////////////////// End Of File ////////////////////////
